/*->h.key */


#define isshift akbd_pollsh()
#define isctrl  akbd_pollctl()
#define isalt   akbd_pollalt()

#define KEYCODE  0
#define KEYDATA  1
#define KEYTIME  2
#define KEYFLAGS 3

#define KEYSUB   1

#define KEYVSHIFT (1<<24)
#define KEYVCTRL  (1<<25)
#define KEYVIRT   (1<<26)
#define KEYVALT   (1<<27)
#define KEYVWIN   (1<<28)
#define KEYVMASK  (0xFF)



#define  XVK_HASH         0xDE
#define  XVK_PERIOD       0xBE
#define  XVK_COMMA        0xBC
#define  XVK_BACKSLASH    0xDC
#define  XVK_BACKAPOST    0xDF
#define  XVK_MINUS        0xBD
#define  XVK_SLASH        0xBF
#define  XVK_SEMICOLON    0xBA
#define  XVK_APOST        0xC0
#define  XVK_LSQBRA       0xDB
#define  XVK_RSQBRA       0xDD
#define  XVK_EQUAL        0xBB



#define  CTRLKEY          (KEYVIRT|KEYVCTRL|VK_CONTROL)
#define  SHIFTKEY									(KEYVIRT|KEYVSHIFT|VK_SHIFT)


#define      PAGEUP       (KEYVIRT|VK_PRIOR)
#define SHFT_PAGEUP       (KEYVIRT|KEYVSHIFT|VK_PRIOR)
#define CTRL_PAGEUP       (KEYVIRT|KEYVCTRL|VK_PRIOR)
#define  ALT_PAGEUP       (KEYVIRT|KEYVALT|VK_PRIOR)
#define CTSH_PAGEUP       (KEYVIRT|KEYVCTRL|KEYVSHIFT|VK_PRIOR)
#define ALSH_PAGEUP       (KEYVIRT|KEYVALT|KEYVSHIFT|VK_PRIOR)


#define      PAGEDOWN     (KEYVIRT|VK_NEXT)
#define SHFT_PAGEDOWN     (KEYVIRT|KEYVSHIFT|VK_NEXT)
#define CTRL_PAGEDOWN     (KEYVIRT|KEYVCTRL|VK_NEXT)
#define  ALT_PAGEDOWN     (KEYVIRT|KEYVALT|VK_NEXT)
#define CTSH_PAGEDOWN     (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_NEXT)
#define ALSH_PAGEDOWN     (KEYVIRT|KEYVSHIFT|KEYVALT|VK_NEXT)



#define      CLEFT        (KEYVIRT|VK_LEFT)
#define      CRIGHT       (KEYVIRT|VK_RIGHT)
#define      CDOWN        (KEYVIRT|VK_DOWN)
#define      CUP          (KEYVIRT|VK_UP)

#define SHFT_CLEFT        (KEYVIRT|VK_LEFT|KEYVSHIFT)
#define SHFT_CRIGHT       (KEYVIRT|VK_RIGHT|KEYVSHIFT)
#define SHFT_CDOWN        (KEYVIRT|VK_DOWN|KEYVSHIFT)
#define SHFT_CUP          (KEYVIRT|VK_UP|KEYVSHIFT)

#define CTRL_CLEFT        (KEYVIRT|VK_LEFT|KEYVCTRL)
#define CTRL_CRIGHT       (KEYVIRT|VK_RIGHT|KEYVCTRL)
#define CTRL_CDOWN        (KEYVIRT|VK_DOWN|KEYVCTRL)
#define CTRL_CUP          (KEYVIRT|VK_UP|KEYVCTRL)


#define ALT_CLEFT         (KEYVIRT|VK_LEFT|KEYVALT)
#define ALT_CRIGHT        (KEYVIRT|VK_RIGHT|KEYVALT)
#define ALT_CDOWN         (KEYVIRT|VK_DOWN|KEYVALT)
#define ALT_CUP           (KEYVIRT|VK_UP|KEYVALT)


#define CTSH_CLEFT        (KEYVIRT|VK_LEFT|KEYVCTRL|KEYVSHIFT)
#define CTSH_CRIGHT       (KEYVIRT|VK_RIGHT|KEYVCTRL|KEYVSHIFT)
#define CTSH_CDOWN        (KEYVIRT|VK_DOWN|KEYVCTRL|KEYVSHIFT)
#define CTSH_CUP          (KEYVIRT|VK_UP|KEYVCTRL|KEYVSHIFT)


#define ALSH_CLEFT        (KEYVIRT|VK_LEFT|KEYVALT|KEYVSHIFT)
#define ALSH_CRIGHT       (KEYVIRT|VK_RIGHT|KEYVALT|KEYVSHIFT)
#define ALSH_CDOWN        (KEYVIRT|VK_DOWN|KEYVALT|KEYVSHIFT)
#define ALSH_CUP          (KEYVIRT|VK_UP|KEYVALT|KEYVSHIFT)



#define      COPY         (KEYVIRT|VK_END)
#define SHFT_COPY         (KEYVIRT|VK_END|KEYVSHIFT)
#define CTRL_COPY         (KEYVIRT|VK_END|KEYVCTRL)
#define CTSH_COPY         (KEYVIRT|VK_END|KEYVCTRL|KEYVSHIFT)
#define  ALT_COPY         (KEYVIRT|VK_END|KEYVALT)
#define ALSH_COPY         (KEYVIRT|VK_END|KEYVALT|KEYVSHIFT)


#define      TAB          (KEYVIRT|VK_TAB)
#define SHFT_TAB          (KEYVIRT|VK_TAB|KEYVSHIFT)
#define CTRL_TAB          (KEYVIRT|VK_TAB|KEYVCTRL)
#define ALT_TAB           (KEYVIRT|VK_TAB|KEYVALT)
#define CTSH_TAB          (KEYVIRT|VK_TAB|KEYVCTRL|KEYVSHIFT)
#define ALSH_TAB          (KEYVIRT|VK_TAB|KEYVALT|KEYVSHIFT)


#define      INSERT       (KEYVIRT|VK_INSERT)
#define SHFT_INSERT       (KEYVIRT|VK_INSERT|KEYVSHIFT)
#define CTRL_INSERT       (KEYVIRT|VK_INSERT|KEYVCTRL)
#define CTSH_INSERT       (KEYVIRT|VK_INSERT|KEYVCTRL|KEYVSHIFT)
#define  ALT_INSERT       (KEYVIRT|VK_INSERT|KEYVALT)
#define ALSH_INSERT       (KEYVIRT|VK_INSERT|KEYVALT|KEYVSHIFT)


#define CTRL_A            (KEYVIRT|KEYVCTRL|'A')
#define CTRL_B            (KEYVIRT|KEYVCTRL|'B')
#define CTRL_C            (KEYVIRT|KEYVCTRL|'C')
#define CTRL_D            (KEYVIRT|KEYVCTRL|'D')
#define CTRL_E            (KEYVIRT|KEYVCTRL|'E')
#define CTRL_F            (KEYVIRT|KEYVCTRL|'F')
#define CTRL_G            (KEYVIRT|KEYVCTRL|'G')
#define CTRL_H            (KEYVIRT|KEYVCTRL|'H')
#define CTRL_I            (KEYVIRT|KEYVCTRL|'I')
#define CTRL_J            (KEYVIRT|KEYVCTRL|'J')
#define CTRL_K            (KEYVIRT|KEYVCTRL|'K')
#define CTRL_L            (KEYVIRT|KEYVCTRL|'L')
#define CTRL_M            (KEYVIRT|KEYVCTRL|'M')
#define CTRL_N            (KEYVIRT|KEYVCTRL|'N')
#define CTRL_O            (KEYVIRT|KEYVCTRL|'O')
#define CTRL_P            (KEYVIRT|KEYVCTRL|'P')
#define CTRL_Q            (KEYVIRT|KEYVCTRL|'Q')
#define CTRL_R            (KEYVIRT|KEYVCTRL|'R')
#define CTRL_S            (KEYVIRT|KEYVCTRL|'S')
#define CTRL_T            (KEYVIRT|KEYVCTRL|'T')
#define CTRL_U            (KEYVIRT|KEYVCTRL|'U')
#define CTRL_V            (KEYVIRT|KEYVCTRL|'V')
#define CTRL_W            (KEYVIRT|KEYVCTRL|'W')
#define CTRL_X            (KEYVIRT|KEYVCTRL|'X')
#define CTRL_Y            (KEYVIRT|KEYVCTRL|'Y')
#define CTRL_Z            (KEYVIRT|KEYVCTRL|'Z')


#define BCTRL_I           CTRL_I
#define BCTRL_R           CTRL_R
#define BCTRL_P           CTRL_P








#define CTRL_LSQUARE      (KEYVIRT|KEYVCTRL|XVK_LSQBRA)
#define ALT_LSQUARE       (KEYVIRT|KEYVALT|XVK_LSQBRA)
#define CTSH_LSQUARE      (KEYVIRT|KEYVCTRL|KEYVSHIFT|XVK_LSQBRA)
#define ALSH_LSQUARE      (KEYVIRT|KEYVALT|KEYVSHIFT|XVK_LSQBRA)

#define CTRL_RSQUARE      (KEYVIRT|KEYVCTRL|XVK_RSQBRA)
#define ALT_RSQUARE       (KEYVIRT|KEYVALT|XVK_RSQBRA)
#define CTSH_RSQUARE      (KEYVIRT|KEYVCTRL|KEYVSHIFT|XVK_RSQBRA)
#define ALSH_RSQUARE      (KEYVIRT|KEYVALT|KEYVSHIFT|XVK_RSQBRA)



#define CTSH_C            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'C')

#define CTSH_I            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'I')
#define ALSH_I            (KEYVIRT|KEYVALT|KEYVSHIFT|'I')

#define CTSH_J            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'J')

#define CTSH_K            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'K')
#define ALSH_K            (KEYVIRT|KEYVALT|KEYVSHIFT|'K')


#define CTSH_P            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'P')
#define ALSH_P            (KEYVIRT|KEYVALT|KEYVSHIFT|'P')

#define CTSH_Q            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'Q')
#define ALSH_Q            (KEYVIRT|KEYVALT|KEYVSHIFT|'Q')

#define CTSH_R            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'R')
#define ALSH_R            (KEYVIRT|KEYVALT|KEYVSHIFT|'R')


#define CTSH_S            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'S')
#define ALSH_S            (KEYVIRT|KEYVALT|KEYVSHIFT|'S')


#define CTSH_X            (KEYVIRT|KEYVCTRL|KEYVSHIFT|'X')
#define ALSH_X            (KEYVIRT|KEYVALT|KEYVSHIFT|'X')



#define ALT_A             (KEYVIRT|KEYVALT|'A')
#define ALT_D             (KEYVIRT|KEYVALT|'D')
#define ALT_G             (KEYVIRT|KEYVALT|'G')
#define ALT_I             (KEYVIRT|KEYVALT|'I')
#define ALT_M             (KEYVIRT|KEYVALT|'M')
#define ALT_R             (KEYVIRT|KEYVALT|'R')
#define ALT_X             (KEYVIRT|KEYVALT|'X')


#define ESCAPE            0x1B

#define ESCPRESS          (KEYVIRT|ESCAPE)
             

#define      DEL          (KEYVIRT|VK_DELETE)
#define CTRL_DEL          (KEYVIRT|VK_DELETE|KEYVCTRL)
#define CTSH_DEL          (KEYVIRT|VK_DELETE|KEYVCTRL|KEYVSHIFT)
#define SHFT_DEL          (KEYVIRT|VK_DELETE|KEYVSHIFT)
#define  ALT_DEL          (KEYVIRT|VK_DELETE|KEYVALT)
#define ALSH_DEL          (KEYVIRT|VK_DELETE|KEYVALT|KEYVSHIFT)


#define      HOME         (KEYVIRT|VK_HOME)
#define CTRL_HOME         (KEYVIRT|KEYVCTRL|VK_HOME)
#define  ALT_HOME         (KEYVIRT|KEYVALT|VK_HOME)
#define SHFT_HOME         (KEYVIRT|KEYVSHIFT|VK_HOME)
#define CTSH_HOME         (KEYVIRT|KEYVCTRL|KEYVSHIFT|VK_HOME)


#define      RETURN       0xD
#define    RETPRESS							(KEYVIRT|VK_RETURN)
#define SHFT_RETURN       (KEYVIRT|KEYVSHIFT|VK_RETURN)
#define CTRL_RETURN       (KEYVIRT|KEYVCTRL|VK_RETURN)
#define CTSH_RETURN       (KEYVIRT|KEYVCTRL|KEYVSHIFT|VK_RETURN)
#define  ALT_RETURN       (KEYVIRT|KEYVALT|VK_RETURN)


#define      PRINTK       (KEYVIRT|VK_PRINT)
#define SHFT_PRINTK       (KEYVIRT|KEYVSHIFT|VK_PRINT)
#define CTRL_PRINTK       (KEYVIRT|KEYVCTRL|VK_PRINT)
#define  ALT_PRINTK       (KEYVIRT|KEYVALT|VK_PRINT)




#define F1           (KEYVIRT|VK_F1)
#define F2           (KEYVIRT|VK_F2)
#define F3           (KEYVIRT|VK_F3)
#define F4           (KEYVIRT|VK_F4)
#define F5           (KEYVIRT|VK_F5)
#define F6           (KEYVIRT|VK_F6)
#define F7           (KEYVIRT|VK_F7)
#define F8           (KEYVIRT|VK_F8)
#define F9           (KEYVIRT|VK_F9)
#define F10          (KEYVIRT|VK_F10)
#define F11          (KEYVIRT|VK_F11)
#define F12          (KEYVIRT|VK_F12)




#define SHFT_F1      (KEYVIRT|KEYVSHIFT|VK_F1)
#define SHFT_F2      (KEYVIRT|KEYVSHIFT|VK_F2)
#define SHFT_F3      (KEYVIRT|KEYVSHIFT|VK_F3)
#define SHFT_F4      (KEYVIRT|KEYVSHIFT|VK_F4)
#define SHFT_F5      (KEYVIRT|KEYVSHIFT|VK_F5)
#define SHFT_F6      (KEYVIRT|KEYVSHIFT|VK_F6)
#define SHFT_F7      (KEYVIRT|KEYVSHIFT|VK_F7)
#define SHFT_F8      (KEYVIRT|KEYVSHIFT|VK_F8)
#define SHFT_F9      (KEYVIRT|KEYVSHIFT|VK_F9)
#define SHFT_F10     (KEYVIRT|KEYVSHIFT|VK_F10)
#define SHFT_F11     (KEYVIRT|KEYVSHIFT|VK_F11)
#define SHFT_F12     (KEYVIRT|KEYVSHIFT|VK_F12)





#define CTRL_F1           (KEYVIRT|KEYVCTRL|VK_F1)
#define CTRL_F2           (KEYVIRT|KEYVCTRL|VK_F2)
#define CTRL_F3           (KEYVIRT|KEYVCTRL|VK_F3)
#define CTRL_F4           (KEYVIRT|KEYVCTRL|VK_F4)
#define CTRL_F5           (KEYVIRT|KEYVCTRL|VK_F5)
#define CTRL_F6           (KEYVIRT|KEYVCTRL|VK_F6)
#define CTRL_F7           (KEYVIRT|KEYVCTRL|VK_F7)
#define CTRL_F8           (KEYVIRT|KEYVCTRL|VK_F8)
#define CTRL_F9           (KEYVIRT|KEYVCTRL|VK_F9)
#define CTRL_F10          (KEYVIRT|KEYVCTRL|VK_F10)
#define CTRL_F11          (KEYVIRT|KEYVCTRL|VK_F11)
#define CTRL_F12          (KEYVIRT|KEYVCTRL|VK_F12)




#define CTSH_F1           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F1)
#define CTSH_F2           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F2)
#define CTSH_F3           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F3)
#define CTSH_F4           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F4)
#define CTSH_F5           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F5)
#define CTSH_F6           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F6)
#define CTSH_F7           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F7)
#define CTSH_F8           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F8)
#define CTSH_F9           (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F9)
#define CTSH_F10          (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F10)
#define CTSH_F11          (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F11)
#define CTSH_F12          (KEYVIRT|KEYVSHIFT|KEYVCTRL|VK_F12)




#define  ALT_F1           (KEYVIRT|KEYVALT|VK_F1)
#define  ALT_F2           (KEYVIRT|KEYVALT|VK_F2)
#define  ALT_F3           (KEYVIRT|KEYVALT|VK_F3)
#define  ALT_F4           (KEYVIRT|KEYVALT|VK_F4)
#define  ALT_F5           (KEYVIRT|KEYVALT|VK_F5)
#define  ALT_F6           (KEYVIRT|KEYVALT|VK_F6)
#define  ALT_F7           (KEYVIRT|KEYVALT|VK_F7)
#define  ALT_F8           (KEYVIRT|KEYVALT|VK_F8)
#define  ALT_F9           (KEYVIRT|KEYVALT|VK_F9)
#define  ALT_F10          (KEYVIRT|KEYVALT|VK_F10)
#define  ALT_F11          (KEYVIRT|KEYVALT|VK_F11)
#define  ALT_F12          (KEYVIRT|KEYVALT|VK_F12)



#define  ALT_SL           (KEYVIRT|KEYVALT|VK_SCROLL)
#define  ALT_BREAK        (KEYVIRT|KEYVALT|VK_PAUSE)



#define KASTERIX          (KEYVIRT|VK_MULTIPLY)
#define KHASH             (KEYVIRT|VK_SEPARATOR)
#define KMINUS            (KEYVIRT|VK_SUBTRACT)
#define KPLUS             (KEYVIRT|VK_ADD)
#define KSLASH            (KEYVIRT|VK_DIVIDE)
#define ENTER             (KEYVIRT|VK_RETURN)
#define KPOINT            (KEYVIRT|VK_DECIMAL)
#define K0                (KEYVIRT|VK_NUMPAD0)
#define K1                (KEYVIRT|VK_NUMPAD1)
#define K2                (KEYVIRT|VK_NUMPAD2)
#define K3                (KEYVIRT|VK_NUMPAD3)
#define K4                (KEYVIRT|VK_NUMPAD4)
#define K5                (KEYVIRT|VK_NUMPAD5)
#define K6                (KEYVIRT|VK_NUMPAD6)
#define K7                (KEYVIRT|VK_NUMPAD7)
#define K8                (KEYVIRT|VK_NUMPAD8)
#define K9                (KEYVIRT|VK_NUMPAD9)
#define NUMLOCK           (KEYVIRT|VK_NUMLOCK)


#define CTRL_KASTERIX     (KEYVIRT|KEYVCTRL|VK_MULTIPLY)
#define CTRL_KHASH        (KEYVIRT|KEYVCTRL|VK_SEPARATOR)
#define CTRL_KMINUS       (KEYVIRT|KEYVCTRL|VK_SUBTRACT)
#define CTRL_KPLUS        (KEYVIRT|KEYVCTRL|VK_ADD)
#define CTRL_KSLASH       (KEYVIRT|KEYVCTRL|VK_DIVIDE)

#define CTRL_K0           (KEYVIRT|KEYVCTRL|VK_NUMPAD0)
#define CTRL_K1           (KEYVIRT|KEYVCTRL|VK_NUMPAD1)
#define CTRL_K2           (KEYVIRT|KEYVCTRL|VK_NUMPAD2)
#define CTRL_K3           (KEYVIRT|KEYVCTRL|VK_NUMPAD3)
#define CTRL_K4           (KEYVIRT|KEYVCTRL|VK_NUMPAD4)
#define CTRL_K5           (KEYVIRT|KEYVCTRL|VK_NUMPAD5)
#define CTRL_K6           (KEYVIRT|KEYVCTRL|VK_NUMPAD6)



#define ALT_KASTERIX      (KEYVIRT|KEYVALT|VK_MULTIPLY)
#define ALT_KHASH         (KEYVIRT|KEYVALT|VK_SEPARATOR)
#define ALT_KMINUS        (KEYVIRT|KEYVALT|VK_SUBTRACT)
#define ALT_KPLUS         (KEYVIRT|KEYVALT|VK_ADD)
#define ALT_KSLASH        (KEYVIRT|KEYVALT|VK_DIVIDE)



#define SHFT_ENTER        (KEYVIRT|KEYVSHIFT|VK_RETURN)
#define CTRL_MINUS        (KEYVIRT|KEYVCTRL|XVK_MINUS)
#define ALT_MINUS         (KEYVIRT|KEYVALT|XVK_MINUS)



#define CTRL_ASTERIX      (KEYVIRT|KEYVCTRL|'8')
#define CTRL_SLASH        (KEYVIRT|KEYVCTRL|XVK_SLASH)
#define CTRL_HASH         (KEYVIRT|KEYVCTRL|XVK_HASH)



#define ALT_ASTERIX       (KEYVIRT|KEYVALT|'8')
#define ALT_SLASH         (KEYVIRT|KEYVALT|XVK_SLASH)
#define ALT_HASH          (KEYVIRT|KEYVALT|XVK_HASH)




#define BACKSPACE         (KEYVIRT|VK_BACK)
#define CTRL_BACKSPACE    (KEYVIRT|VK_BACK|KEYVCTRL)
#define  ALT_BACKSPACE    (KEYVIRT|VK_BACK|KEYVALT)
#define SHFT_BACKSPACE    (KEYVIRT|VK_BACK|KEYVSHIFT)
#define CTSH_BACKSPACE    (KEYVIRT|VK_BACK|KEYVSHIFT|KEYVCTRL)
#define ALSH_BACKSPACE    (KEYVIRT|VK_BACK|KEYVSHIFT|KEYVALT)

#define P_SPACE           (KEYVIRT| VK_SPACE)
#define P_CTRL_SPACE      (KEYVIRT| VK_SPACE|KEYVCTRL)
#define P_SHFT_SPACE      (KEYVIRT| VK_SPACE|KEYVSHIFT)




#define KEYNORM   (0<<8)
#define KEYSHIFT  (1<<8)
#define KEYCTRL   (2<<8)
#define KEYALT    (3<<8)
#define KEYCTSH   (4<<8)
#define KEYALSH   (5<<8)
#define KEYALCT   (6<<8)
#define KEYALCTSH (7<<8)
#define KEYWIN    (8<<8)
#define KEYWINSH		(9<<8)
#define KEYWINCT		(10<<8)
#define KEYWINAL		(11<<8)
#define KEYWINCTSH	(12<<8)
#define KEYWINALSH	(13<<8)
#define KEYWINALCT (14<<8)
#define KEYWINALCTSH	(15<<8)

#define KEYSHIFTN 16


#define DIGIT1   17
#define DIGIT2   18
#define DIGIT3   19
#define DIGIT4   20
#define DIGIT5   21
#define DIGIT6   22
#define DIGIT7   23
#define DIGIT8   24
#define DIGIT9   25
#define DIGIT0   26

#define COMMAINDEX  82
#define POINTINDEX  83
#define SEMICOINDEX 68
#define SQUOTEINDEX 69



extern int    isbadfunc(int key);
extern int    isfunc(int key);
extern int    isasciitextkey(int key);


#define KEYNONE -1

extern int    keycanonicaltype(char * string);
extern int    keytype(char * string);
extern int    keytypetext(char * string);
extern int    keycode2canonical(int code);
extern int    keycanonical2code(int ccode);
extern char * keystringcanonical(int ccode);
extern char * keylongstringcanonical(int ccode);
extern char * keystring(int code);
extern int    keypressfromchar(int ch);

extern os_error * keyboard_on(int autorepeat);
extern os_error * keyboard_off(void);



#define KEYNUMLOCKKEY    0x1
#define KEYBREAKKEY      0x2
#define KEYAUTORATE      0x4
#define KEYACTIONKEY     0x8
#define KEYSCROLLLOCKKEY 0x10


extern os_error * setkeyboardmode(int caps);
extern os_error * initkeyboard(int caps);

extern os_error * scrollkey(wimp_w window,int * key);
