
#define PRPSTYPE 1
#define PRNOTYPE 0

typedef os_error * (*osprintfn)(wimp_redrawstr * r,int flags,void * data,uservalue userhandle);
typedef os_error * (*osabortprintfn)(wimp_w handle,uservalue userhandle,os_error * err,int * result);

extern os_error * osprgetname(char * string,int len);
extern os_error * osprintinitdbox(void);
extern os_error * osprintdbox(wimp_w parent,wimp_w handle,uservalue userhandle,osprintfn printfn,osabortprintfn abortfn,int flags,int * data);
extern os_error * osprintpagedbox(wimp_w parent);


extern os_error * osprintstartdoc(char * docname,char * filename);
extern os_error * osprintenddoc(void);
extern os_error * osprintstartpage(void);
extern os_error * osprintendpage(void);
extern os_error * osprintabortdoc(void);
extern os_error * osprintmargins(int * left,int * right,int * top,int * bottom,int xres,int yres);
extern os_error * osprintprofile(int * size,char * buffer);


extern os_error * osxprintinit(void);
extern os_error * osxprintpropertiesdbox(wimp_w parent,int * okp);

#define PRXRAW  1
#define PRXRAW2 2

extern os_error * osxprint(wimp_w handle,uservalue userhandle,void * data,osprintfn printfn,osabortprintfn abortfn,int flags);

extern os_error * osprgetnamen(int n,char * string,int len);
extern os_error * osprgetdefaultname(char * string,int len);
extern os_error * osprgetcurrentname(char * string,int len);
extern os_error * osprsetcurrentname(char * string);
extern os_error * osprgetcurrenttype(int * type);
extern os_error * osprinterpslevel(int * level);
extern os_error * osxprintmargins(int * left,int * right,int * top,int * bottom,int * width,int * height,int xres,int yres);
extern os_error * osxactiveprintmargins(int * left,int * right,int * top,int * bottom,int * width,int * height,int xres,int yres);
extern os_error * osxprinterdata(char * dataname,int maxsize);


extern os_error * osgoprinter(void);
extern os_error * osgonormal(void);
extern os_error * oswriteprinter(char * string);
extern os_error * oswriteprinterf(char * format,...);
extern os_error * oswriteprinterdata(char * dp,int len);


#define PRPROP_READ  0x1
#define PRPROP_WRITE 0x2
#define PRPROP_SET   0x1

extern os_error * osxprintpropscale(int newscale,int * oldscale,int inmode,int * outmode);
extern os_error * osxprintpropcopies(int newcopies,int * oldcopies,int inmode,int * outmode);
extern os_error * osxprintpropcollate(int newcollate,int * oldcollate,int inmode,int * outmode);
extern os_error * osxprintproporient(int neworient,int * oldorient,int inmode,int * outmode);
extern os_error * osxprintpropttoption(int newttoption,int * oldttoption,int inmode,int * outmode);


extern os_error * osxprintcachefontsubs(void);
extern os_error * osxprintmapfont(TCHAR * windows,TCHAR ** printer);





