
#include <stdafx.h>

#include "commdlg.h"
#include "commctrl.h"
#include "dlgs.h"



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "werr.h"


#include "wos.h"
#include "poll.h"
#include "fsx.h"
#include "err.h"
#include "etc.h"
#include "bits.h"
#include "filetype.h"
#include "trans.h"


#include "deb.h"


#include "load.h"















static TCHAR loadfilterbuffer[256]; // ="CrossStar Grid (*.crx)\0*.crx\0\0\0";



static os_error * getloadfilename(char * name,wimp_w parent)
{
 OPENFILENAME ofn;
 TCHAR        dir[MAX_PATH];
 TCHAR        filename[MAX_PATH];


 memset(&ofn,0,sizeof(OPENFILENAME));

 ofn.hwndOwner=(HWND)parent;
 ofn.lStructSize=((char*)&ofn.pvReserved)-((char*)&ofn.lStructSize);//sizeof(OPENFILENAME);

 ofn.lpstrFilter=loadfilterbuffer;

 ofn.lpstrCustomFilter=NULL;
 ofn.nMaxCustFilter=0;

 ofn.nFilterIndex=1;

 ofn.lpstrFile=fs_leaf(name);
 ofn.lpstrInitialDir=dir;
 xstrncpy(dir,name,ofn.lpstrFile-name);
 strcpy(filename,ofn.lpstrFile);
 ofn.lpstrFile=filename;

 ofn.nMaxFile=MAX_PATH;

 ofn.Flags=OFN_FILEMUSTEXIST;


 if(GetOpenFileName(&ofn))
 {
  strcpy(name,filename);
  return(NULL);
 }
 else
 {

  return(geterror(ELOADCANCELLED));
 }
}





os_error * openloadparent(TCHAR * name,int * optp,loadoptstr * opts,int optn,loadfn load,uservalue userhandle,wimp_w parent)
{
 os_error * err;
 int        ack;
 int        type;
 TCHAR    * p;
 int        i;
 int        j;
 TCHAR      extension[64];

 p=loadfilterbuffer;

 for(i=0;i<optn;i++)
 {
  xzstrncpyu(p,opts[i].description,NITEM(loadfilterbuffer)-(p-loadfilterbuffer));
  trans(p,NITEM(loadfilterbuffer)-(p-loadfilterbuffer));
  p+=ustrlen(p)+1;

  for(j=0;j<opts[i].ntypes;j++)
  {
   if(opts[i].types[j]==-1) strcat(p,"*.*;");
   else
   {
    getextension(opts[i].types[j],extension);
    xsprintfu(NITEM(loadfilterbuffer)-(p-loadfilterbuffer),NULL,p,"*.%s;",extension);
   }
//   cprintf("p %s",p);
   p+=ustrlen(p);
  }

		if(p<(loadfilterbuffer+NITEM(loadfilterbuffer)-1))
		{
   *p++=0;
		}
 }

	if(p<(loadfilterbuffer+NITEM(loadfilterbuffer)-1))
	{
  *p++=0;
	}

 err=getloadfilename(name,parent);
 if(!err)
 {
  type=fs_filetypefromextension(name);
  if(load)
  {
   err=load(name,type,userhandle,0);

  }
  else
  {
   fakedataopen(type,name,&ack);

  }
 }
 else
 {
  if(err->errnum==ELOADCANCELLED) err=NULL;

 }

 return(err);
}

